export interface DecoratorHandler {
  onClassDecorator?: <TFunction extends Function>(target: TFunction) => TFunction | void;
  onPropertyDecorator?: (target: Object, propertyKey: string | symbol) => void;
  onMethodDecorator?: <T>(target: Object, propertyKey: string | symbol,
                          descriptor: TypedPropertyDescriptor<T>) => TypedPropertyDescriptor<T> | void;
  onParameterDecorator?: (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
}

export default DecoratorHandler;
